## How to contribute
There are many ways that you can contribute to the WinJS project:
* Submit a bug
* Verify fixes for bugs
* Submit a code fix for a bug
* Submit a feature request
* Submit a unit test
* Tell others about the WinJS project
* Tell the developers how much you appreciate the project

## Contributing Code
Note that all code submissions will be rigorously reviewed and tested by the team, and only those that meet an extremely high bar for both quality and design/roadmap appropriateness will be merged into the source.

### Pull Requests
You will need to sign a [Contribution License Agreement](https://cla.microsoft.com/) ([CLA](https://cla.microsoft.com/)) before submitting your pull request be it a feature or a bug fix. To complete the CLA, you will need to submit the request via the form and then electronically sign the CLA when you receive the email containing the link to the document.

This needs to only be done once for any Microsoft open source project.

### Feature Requests
Before submitting a feature or substantial code contribution please discuss it with the team and ensure it aligns with the project's [roadmap](https://github.com/winjs/winjs/wiki/Roadmap).

## Contributing to README and Wiki
You do not need to sign a Contribution License Agreement if you are just contributing to the README or the Wiki. By submitting a contribution to the README or the Wiki, you are contributing it under the [Creative Commons CC0 1.0 Universal Public Domain Dedication](http://creativecommons.org/publicdomain/zero/1.0/).
